#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,i,p,q;
    long long d,k,e,uk=0;
    vector<pair<long long,int>> v1;
    cin>>n>>q;
    for (i=0;i<n;i++)
    {
        cin>>d>>p;
        v1.push_back(make_pair(d,p));
    }
    for (i=0;i<q;i++)
    {
        cin>>k;
        uk=0;
        for (int j=0;j<n;j++)
        {
            if (v1[j].first<=k)
            {
            e=k-v1[j].first;
            if (v1[j].second<=e)
            {
                uk=uk+v1[j].second;
            }
            else
            {
                uk=uk+e+1;
            }
            }
        }
        cout<<uk<<"\n";
    }
    return 0;
}